using System;
using System.Collections;
using System.Collections.Specialized;
using System.Text;
using System.Text.RegularExpressions;


public class ChatUtility
{
	static char[] staticchars2 = new char[] { '^', ';', ':', '|', '<', '>', '#', '/', '%', '?', '!' };

	static string PropEncode(string str)
	{
		if (str.IndexOfAny(staticchars2) != -1)
		{
			str = str.Replace("^", "^0");
			str = str.Replace(";", "^1");
			str = str.Replace(":", "^2");
			str = str.Replace("|", "^3");
			str = str.Replace("<", "^4");
			str = str.Replace(">", "^5");
			str = str.Replace("#", "^6");
			str = str.Replace("/", "^7");
			str = str.Replace("%", "^8");
			str = str.Replace("?", "^9");
			str = str.Replace("!", "^a");
		}
		return str;
	}
	static string PropDecode(string str)
	{
		if (str.IndexOf('^') != -1)
		{
			str = str.Replace("^a", "!");
			str = str.Replace("^9", "?");
			str = str.Replace("^8", "%");
			str = str.Replace("^7", "/");
			str = str.Replace("^6", "#");
			str = str.Replace("^5", ">");
			str = str.Replace("^4", "<");

			str = str.Replace("^3", "|");
			str = str.Replace("^2", ":");
			str = str.Replace("^1", ";");
			str = str.Replace("^0", "^");
		}
		return str;
	}


	public static string GetProperties(NameValueCollection props)
	{
		StringBuilder sb = new StringBuilder();
		foreach (string eachkey in props.Keys)
		{
			string key = eachkey;
			string val = props[key];

			if (val == null)
				continue;

			if (sb.Length != 0)
				sb.Append("|");

			key = PropEncode(key);
			val = PropEncode(val);

			sb.Append(key).Append(":").Append(val);
		}
		if (sb.Length == 0)
			return null;
		return sb.ToString();
	}
	public static NameValueCollection GetProperties(string str)
	{
		if (str == null) return null;
		if (str.Length == 0) return null;

		NameValueCollection nvc = new NameValueCollection();

		foreach (string pair in str.Split('|'))
		{
			string[] pairs = pair.Split(':');
			string key = PropDecode(pairs[0]);
			string val = PropDecode(pairs[1]);

			nvc.Add(key, val);
		}

		return nvc;
	}


}
