﻿using System;
using System.Collections.Generic;
using System.Web;
using System.IO;
using System.Text;
using System.Threading;

[Serializable]
public class RequestData
{
	public string type;
	public Dictionary<string, object>[] args;
}


public class ChatApiNotificationHandler : IHttpHandler
{
	static bool ENABLE_LOG_REQUEST_TO_FILE = true;

	static string apikey = System.Configuration.ConfigurationManager.AppSettings["ChatApiKey"];


	static bool HandleChatNotification(RequestData rd,TextWriter log)
	{
		return NotificationCodeForCrm.HandleChatNotification(rd, log);

		//Dictionary<string, object> data = rd.args[0];

		//switch (rd.type)
		//{
		//	case "AGENT_ONLINE":	//AGENT LOGIN CONSOLE			args=agent,channel
		//		break;
		//	case "AGENT_OFFLINE":	//AGENT CLOSE CONSOLE			args=agent,channel
		//		break;
		//	case "VISITOR_ONLINE":	//VISITOR ENTER WEBSITE			args=visitor,channel
		//		break;
		//	case "VISITOR_OFFLINE":	//VISITOR LEAVE WEBSITE			args=visitor,channel
		//		break;

		//	case "AGENT_ENTER":	//AGENT ENTER CHAT ROOM				args=agent,channel,visitor
		//		{
		//			ChatApiNS.ChatApiWebService sc = new ChatApiNS.ChatApiWebService();
		//			sc.Url = System.Configuration.ConfigurationManager.AppSettings["ChatApiServiceUrl"];

		//			string message = "Welcome , click more information about this visitor : " + (string)rd.args[2]["DisplayName"];
		//			sc.SendAnnouncement(apikey, (string)rd.args[1]["ChannelName"], (string)rd.args[0]["UserId"], message,
		//				"<a href='http:///' target='_blank' style='color:red'>" + System.Web.HttpUtility.HtmlEncode(message) + "</a>"
		//				);
		//		}
		//		break;
		//	case "AGENT_LEAVE":	//AGENT LEAVE CHAT ROOM				args=agent,channel,visitor
		//		break;
		//	case "VISITOR_ENTER":	//VISITOR ENTER CHAT ROOM		args=chatter,channel,visitor
		//		{
		//			ChatApiNS.ChatApiWebService sc = new ChatApiNS.ChatApiWebService();
		//			sc.Url = System.Configuration.ConfigurationManager.AppSettings["ChatApiServiceUrl"];

		//			string message = "Welcome , this message is sent from api test website.";
		//			sc.SendAnnouncement(apikey, (string)rd.args[1]["ChannelName"], (string)rd.args[0]["UserId"], message, 
		//				"<span style='color:red'>"+System.Web.HttpUtility.HtmlEncode(message)+"</span>"
		//				);
		//		}
		//		break;
		//	case "VISITOR_LEAVE":	//VISITOR LEAVE CHAT ROOM		args=chatter,channel,visitor
		//		break;

		//	case "OFFLINEMESSAGE_SEND":	//							args=msgdata,visitor
		//		break;

		//	case "MAILTEMPLATE_SEND":	//							args=msgdata,moredata
		//		break;

		//	case "VISITOR_WAITCHAT":	//							args=visitor
		//		break;
		//	case "VISITOR_MISSCHAT":	//							args=visitor
		//		break;
		//	case "VISITOR_BEACCEPTED":	//							args=visitor
		//		break;

		//	case "CONVERSATION_END":	//							args=visitor,channel
		//		{
		//			ChatApiNS.ChatApiWebService sc = new ChatApiNS.ChatApiWebService();
		//			sc.Url = System.Configuration.ConfigurationManager.AppSettings["ChatApiServiceUrl"];
		//			object sid;
		//			if(rd.args[1].TryGetValue("SessionId",out sid))
		//			{
		//				ChatApiNS.ChatMsgData[] msgs = sc.LoadSessionMessages(apikey, Convert.ToInt32(sid));
		//				log.WriteLine(" Messages : " + msgs.Length);
		//				foreach (ChatApiNS.ChatMsgData msg in msgs)
		//				{
		//					log.WriteLine(msg.Sender + " : " + msg.Text);
		//				}
		//			}
		//		}
		//		break;
		//	case "CONVERSATION_START":	//							args=visitor,channel
		//		break;

		//	case "CONVERSATION_MESSAGE":	//						args=msgdata,visitor,channel
		//		{
		//			ChatApiNS.ChatApiWebService sc = new ChatApiNS.ChatApiWebService();
		//			sc.Url = System.Configuration.ConfigurationManager.AppSettings["ChatApiServiceUrl"];

		//			string message = "Test......";
		//			sc.SendAnnouncement(apikey, (string)rd.args[2]["ChannelName"], (string)rd.args[1]["UserId"], message, 
		//				"<span style='color:red'>"+System.Web.HttpUtility.HtmlEncode(message)+"</span>"
		//				);
		//		}
		//		break;
		//}


	}


	public bool IsReusable
	{
		get
		{
			return false;
		}
	}

	[Serializable]
	public class ChatApiParam
	{
		public string type;
		public Dictionary<string, object> data;
	}

	public void ProcessRequest(HttpContext context)
	{
		StreamReader sr = new StreamReader(context.Request.InputStream, System.Text.Encoding.UTF8);
		string jsonstr = sr.ReadToEnd();

		context.Response.ContentType = "text/plain";
		context.Response.Write("OK");

		if (context.Request.HttpMethod != "POST")
			return;



		StringBuilder log = new StringBuilder();

		if (ENABLE_LOG_REQUEST_TO_FILE)
		{
			log.Append(context.Request.Url);

			log.AppendLine();

			for (int hi = 0; hi < context.Request.Headers.Count; hi++)
			{
				string key = context.Request.Headers.GetKey(hi);
				string val = context.Request.Headers.Get(hi);
				log.Append(key + " : " + val);
				log.AppendLine();
			}

			log.AppendLine();

			log.Append(jsonstr);

			log.AppendLine().AppendLine();
		}

		string arghash = context.Request.Headers["ChatApiJsonHash"];


		//the asp.net request shall be return quickly and process the rest logic in another thread asynchronously.
		QueueAndStartThread(delegate
		{

			bool logtofile = ENABLE_LOG_REQUEST_TO_FILE;

			string filename = "chatapi_notification_" + DateTime.Now.Ticks;

			try
			{
				System.Security.Cryptography.SHA1CryptoServiceProvider sha1 = new System.Security.Cryptography.SHA1CryptoServiceProvider();
				byte[] srcbin = Encoding.UTF8.GetBytes(apikey + ":" + jsonstr);
				byte[] hashbin = sha1.ComputeHash(srcbin);
				string hash = Convert.ToBase64String(hashbin);

				if (hash != arghash)
				{
					throw new Exception("ChatApiJsonHash NOT MATCH");
				}

				System.Web.Script.Serialization.JavaScriptSerializer jss = new System.Web.Script.Serialization.JavaScriptSerializer();
				RequestData data = jss.Deserialize<RequestData>(jsonstr);
				//RequestData data = (RequestData)Newtonsoft.Json.JsonConvert.DeserializeObject(jsonstr, typeof(RequestData));

				filename += "_" + data.type;

				TextWriter writer = new StringWriter(log);
				bool allowlog = HandleChatNotification(data, writer);

				if (!allowlog)
					logtofile = false;
			}
			catch (Exception x)
			{
				filename += "_" + x.GetType().Name;

				log.AppendLine();
				log.AppendLine();
				log.Append(x);
			}

			if (logtofile)
			{
				string datafolder = Path.Combine(HttpRuntime.AppDomainAppPath, "App_Data");
				string logfile = Path.Combine(datafolder, filename + ".log");

				File.WriteAllText(logfile, log.ToString());
			}

		});
	}


	static Queue<Action> _queue = new Queue<Action>();
	static bool _threadstarted = false;

	/// <summary>
	/// Queue the tasks and execute them one by one
	/// </summary>
	static void QueueAndStartThread(Action func)
	{

		lock (_queue)
		{
			_queue.Enqueue(func);

			if (!_threadstarted)
			{
				_threadstarted = true;
				ThreadPool.QueueUserWorkItem(ThreadFunc);
			}
		}
	}
	static void ThreadFunc(object state)
	{
		while (true)
		{
			Action action;
			lock (_queue)
			{
				if (_queue.Count == 0)
				{
					_threadstarted = false;
					return;
				}

				action = _queue.Dequeue();
			}

			try
			{
				action();
			}
			catch (Exception x)
			{
				//TODO: log error
			}
		}
	}

}
