﻿<%@ Page Language="C#" AutoEventWireup="true" %>

<script runat="server">

	string apikey = System.Configuration.ConfigurationManager.AppSettings["ChatApiKey"];
	ChatApiNS.ChatApiWebService sc = new ChatApiNS.ChatApiWebService();

	string helloworldresult;

	protected override void OnLoad(EventArgs e)
	{
		base.OnLoad(e);

		sc.Url = System.Configuration.ConfigurationManager.AppSettings["ChatApiServiceUrl"];

		helloworldresult = sc.HelloWorld(apikey);
	
		Microsoft.Crm.Sdk.Messages.WhoAmIResponse res = (Microsoft.Crm.Sdk.Messages.WhoAmIResponse)
			NotificationCodeForCrm.OpenCrmSvc().Execute(new Microsoft.Crm.Sdk.Messages.WhoAmIRequest());

		myinfo = (SystemUser)NotificationCodeForCrm.OpenCrmSvc().Retrieve("systemuser", res.UserId, new Microsoft.Xrm.Sdk.Query.ColumnSet(true));


	}

	SystemUser myinfo;
</script>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<title></title>
</head>
<body>

	
	<%=myinfo.Id+ ":"+ myinfo.FirstName+" "+myinfo.LastName %>
	<hr />

	<%=Server.HtmlEncode(helloworldresult) %>

	<fieldset runat="server" id="fieldset1">
		<legend>Configs</legend>
		<%
			string[] keys = sc.LoadConfigKeys(apikey);
			string[] vals = sc.LoadConfig(apikey, keys);
			
		%>
		<%for (int ki = 0; ki < keys.Length; ki++) %>
		<%{ %>
		<%=keys[ki] %> : <%=vals[ki] %>
		<br />
		<%} %>
	</fieldset>

	<fieldset runat="server" id="fieldset2">
		<legend>Agents</legend>
		<%
			ChatApiNS.ChatApiAgent[] agents = sc.LoadAgents(apikey);
		%>
		<%foreach (ChatApiNS.ChatApiAgent agent in agents) %>
		<%{ %>
		<%=agent.UserId  %> : <%=agent.LoginName %> : <%=agent.DisplayName %> : <%=agent.Email %>
		<br />
		<%} %>
	</fieldset>

	<fieldset runat="server" id="fieldset3">
		<legend>Departments</legend>
		<%
			ChatApiNS.ChatApiDepartment[] deps = sc.LoadDepartments(apikey);
		%>
		<%foreach (ChatApiNS.ChatApiDepartment dep in deps) %>
		<%{ %>
		<%=dep.DepartmentId %>:<%=dep.Name %>
		<br />
		<div style="margin-left: 52px;">
			<%foreach (ChatApiNS.ChatApiAgent agent in dep.Agents) %>
			<%{ %>
			<%=agent.UserId  %> : <%=agent.LoginName %> : <%=agent.DisplayName %> : <%=agent.Email %>
			<br />
			<%} %>
		</div>
		<%} %>
	</fieldset>


	<fieldset runat="server" id="fieldset4">
		<legend>Server Status</legend>

		<%
			ChatApiNS.ChatApiStatus cas = sc.LoadChatApiStatus(apikey);
			string casjson = Newtonsoft.Json.JsonConvert.SerializeObject(cas,Newtonsoft.Json.Formatting.Indented);
		%>

		<textarea style="width:1500px;height:500px"><%=Server.HtmlEncode(casjson) %></textarea>

	</fieldset>



</body>
</html>
